;this block is only passable when mario is sliding. Don't worry about
;making the block solid while the player inside and dying, if mario's
;speed is too slow, it boost mario outs like the continuer block would.
;(and it also disable controls that can cancel's mario's sliding too).
;behaves #$130. (because dropped carryable sprites can "stick" into walls).
db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP SpriteV : JMP SpriteH : JMP MarioCape
JMP MarioFireBall : JMP TopCorner : JMP BodyInside : JMP HeadInside

!left_speed	= $D1	;minimal speed for left sliding ($D1 is the default left speed)
			;slow to fast: #$FF -> #$80.
!right_speed	= $2F	;minimal speed for right sliding ($2F is the default right speed)
			;slow to fast: #$01 -> #$7F.
			;speed note: to have "equal" left and right speed, use the
			;forumla: L=#$100-R

TopCorner:
MarioAbove:
MarioSide:
HeadInside:
BodyInside:
MarioBelow:
	LDA $13ED		;\if mario isn't sliding
	CMP #$1C		;|
	BNE Return		;/then return
	LDA $72			;\if mario is in air
	BNE Return		;/return
	LDA #$1C		;\keep sliding
	STA $13ED		;/
	STZ $15			;\disable controls
	LDA #$CF		;|(execept START,SELECT
	TRB $16			;|L and R buttons)
	LDA #$C0		;|
	TRB $17			;|
	TRB $18			;/
	LDA $1497		;\makes mario flash if he's isn't
	BNE u_flash		;|(this fixes the bug that if sliding flashing immumity
	LDA #$01		;|mario touches the block will lower the invulnerbilty timer
	STA $1497		;|instantly).
u_flash:			;/
	LDY #$00		;\become passable
	LDA #$25		;|
	STA $1693		;/
	LDA $7B			;\if mario sliding left
	BMI slide_left		;/then go to left slide
				;otherwise if going right
	CMP.b #!right_speed+01	;\if mario is going faster than the block
	BCS Return		;/then return (would slow him down if faster)
	LDA #!right_speed	;\set mario right speed if slower
	STA $7B			;/
	BRA Return		;>so it doesn't also run the left code
slide_left:
	CMP #!left_speed	;\if mario is going faster than the block
	BCC Return		;/then return (would slow him down if faster)
	LDA #!left_speed
	STA $7B
	BRA Return
SpriteV:
SpriteH:
MarioCape:
MarioFireBall:
Return:
RTL
