;place this ABOVE the actual "ramp" that goes up (from left to right)
;in a 45' slope
;behaves #$25
db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide : JMP SpriteV : JMP SpriteH : JMP MarioCape
JMP MarioFireBall : JMP TopCorner : JMP BodyInside : JMP HeadInside

!height	= $80		;>from low to high: #$FF -> #$80
!long_distance = $40	;>from short to far: #$01 -> #$7F

BodyInside:
MarioBelow:
	LDA $13ED	;\must be sliding
	CMP #$1C	;|
	BNE Return	;/
	LDA $72		;\must be on the ground
	BNE Return	;/
	LDA $7B		;\if going left or going too slow
	BMI Return	;|then return
	CMP #$2A	;|
	BCC Return 	;/
	LDA $16		;\if the player press normal jump
	AND #$80	;|
	BNE n_jump	;/then go to normal jump
	LDA $18		;\if player press spin jump
	AND #$80	;|
	BEQ Return	;/then spin jump

	LDA #!height		;\set spinjump speed
	STA $7D			;/
	LDA #$04		;\spinjump sound
	STA $1DFC		;/
	LDA #$01
	STA $140D
	BRA both_jumps
n_jump:
	LDA #!height		;\set normaljump speed
	STA $7D			;/
	LDA #$01		;\jump sound
	STA $1DFA		;/
both_jumps:
	LDA #$0C		;\set long jump
	STA $72			;/
	STZ $13ED		;>reset sliding flag
	LDA #$01		;\face right
	STA $76			;/
	LDA #!long_distance
	STA $7B
TopCorner:
HeadInside:
MarioAbove:
MarioSide:

SpriteV:
SpriteH:
MarioFireBall:
MarioCape:
Return:
RTL