;if mario slide into this floor block, will make him slide indefinitely.
;this block has no custom graphic, but you can make it look like a normal
;ground
;behaves #$100, or #$130.

db $42
JMP Return : JMP Main : JMP Return : JMP Return : JMP Return : JMP Return
JMP Return : JMP Main : JMP Return : JMP Return


!left_speed	= $D1	;minimal speed for left sliding ($D1 is the default left speed)
			;slow to fast: #$FF -> #$80.
!right_speed	= $2F	;minimal speed for right sliding ($2F is the default right speed)
			;slow to fast: #$01 -> #$7F.
			;speed note: to have "equal" left and right speed, use the
			;forumla: L=#$100-R

Main:
	LDA $72			;\if mario is in the air
	BNE Return		;/return
	LDA $13ED		;\if mario not sliding
	CMP #$1C		;|
	BNE Return		;/return
	LDA $7B			;\if sliding mario lands straight down 
	BEQ Return		;/on this block, return.
	LDA #$1C		;\otherwise maintain sliding
	STA $13ED		;/
	LDA #$03		;\so mario cannot accidently cancel
	TRB $15			;/sliding.
	LDA $7B			;\if mario sliding left
	BMI slide_left		;/then go to left slide
				;otherwise if going right
	CMP.b #!right_speed+01	;\if mario is going faster than the block
	BCS Return		;/then return (would slow him down if faster)
	LDA #!right_speed	;\set mario right speed if slower
	STA $7B			;/
	BRA Return		;>so it doesn't also run the left code
slide_left:
	CMP #!left_speed	;\if mario is going faster than the block
	BCC Return		;/then return (would slow him down if faster)
	LDA #!left_speed
	STA $7B
Return:
RTL
